create_clock -period 8.0 -name ssync_rx_clk [get_ports ssync_rx_clk]

# PLL phase-shifts the latching clock by 90 degrees, which will be constrained by derive_pll_clocks:
derive_pll_clocks

derive_clock_uncertainty

# Create virtual clock for external device:
create_clock -period 8.0 -name ssync_clk_ext

# Case 1:  External device sends clock and data edge-aligned, and FPGA will phase-shift the clock 90 degrees
# External Delays: The external -max delay is 0.7ns and -min is -0.6ns.  This means the data might come into the FPGA up to 0.7ns after the clock or 0.6ns before.  
# FPGA Requirement - Setup: The setup relationship is 2ns and the -max value is 0.7ns.  The FPGA's data path can be 1.3ns longer than the clock path and still meet timing.
# FPGA Requirement - Hold: The hold relationship is -2ns and the -min is -0.6ns.  The FPGA's data path can be 1.4ns shorter than the clock path and still meet timming.
# Since this is Case 1, there is a 90 degree phase-shift of the clock on top of this skew requirements, which centers the clock onto the data eye.
set_input_delay -clock ssync_clk_ext -max 0.7 [get_ports {ssync_rx_data[*]}]
set_input_delay -clock ssync_clk_ext -min -0.6 [get_ports {ssync_rx_data[*]}]
set_input_delay -clock ssync_clk_ext -max 0.7 [get_ports {ssync_rx_data[*]}] -clock_fall -add_delay
set_input_delay -clock ssync_clk_ext -min -0.6 [get_ports {ssync_rx_data[*]}] -clock_fall -add_delay


