# Shift clock coming into the FPGA by 90 degrees so it is explicitly shifted from external virtual clock ssync_clk_ext
create_clock -period 8.0 -name ssync_rx_clk [get_ports ssync_rx_clk] -waveform {2.0 6.0}

derive_pll_clocks

derive_clock_uncertainty

create_clock -period 8.0 -name ssync_clk_ext 

# Case 2:  External device phase-shifts the clock it send to the FPGA by 90 degrees, so it is center-aligned
# External Delays: The external -max delay is 0.7ns and -min is -0.6ns.  This means the data might skew be skewed by +0.7ns down to -0.6ns from the ideal center-alignment  
# FPGA Requirement - Setup: The setup relationship is 2ns and the -max value is 0.7ns.  The FPGA's data path can therfore be 1.3ns longer than the clock path and still meet timing.
# FPGA Requirement - Hold: The hold relationship is -2ns and the -min is -0.6ns.  The FPGA's data path can be 1.4ns shorter than the clock path and still meet timming.
# Since this is Case 2, the clock already comes in center-aligned, and the FPGA is just maintaining that relationship by trying to match skew
set_input_delay -clock ssync_clk_ext -max 0.7 [get_ports {ssync_rx_data[*]}]
set_input_delay -clock ssync_clk_ext -min -0.6 [get_ports {ssync_rx_data[*]}]
set_input_delay -clock ssync_clk_ext -max 0.7 [get_ports {ssync_rx_data[*]}] -clock_fall -add_delay
set_input_delay -clock ssync_clk_ext -min -0.6 [get_ports {ssync_rx_data[*]}] -clock_fall -add_delay

