create_clock -period 8.0 -name ssync_rx_clk [get_ports ssync_rx_clk]

# PLL phase-shifts the latching clock by 90 degrees, which will be constrained by derive_pll_clocks:
derive_pll_clocks

derive_clock_uncertainty

# Create virtual clock for external device:
create_clock -period 8.0 -name ssync_clk_ext

# Case 1:  External device sends clock and data edge-aligned, and FPGA will phase-shift the clock 90 degrees

# The following is the amount of allowed skew on the transmitter, pulled directly from the transmitter FPGA's .sdc
set tx_output_skew_max 0.360 
set tx_output_skew_min -0.360

# Optional:  After compiling we found there is lots of margin on the receiver but very little on the transmitter.  We could change the following variables
# in both .sdc files to +/-760ps, which give 400ps of slack to the transmitter and take it away from the reciver:
#set tx_output_skew_max 0.760 
#set tx_output_skew_min -0.760

# Data to clock board skew.  Positive number is the amount data delay can be larger than clock delay, negative number is how much shorter it can be.
set brd_skew_max 0.1
set brd_skew_min -0.1

set ssync_input_delay_max [expr $tx_output_skew_max + $brd_skew_max]
set ssync_input_delay_min [expr $tx_output_skew_min + $brd_skew_min]

set_input_delay -clock ssync_clk_ext -max $tx_output_skew_max [get_ports {ssync_rx_data[*]}]
set_input_delay -clock ssync_clk_ext -min $tx_output_skew_min [get_ports {ssync_rx_data[*]}]
set_input_delay -clock ssync_clk_ext -max $tx_output_skew_max [get_ports {ssync_rx_data[*]}] -clock_fall -add_delay
set_input_delay -clock ssync_clk_ext -min $tx_output_skew_min [get_ports {ssync_rx_data[*]}] -clock_fall -add_delay


