create_clock -period 4.0 -name ssync_rx_clk [get_ports ssync_rx_clk] 

derive_pll_clocks

derive_clock_uncertainty

# Create virtual clock for external device.  The alternative solution does not phase-shift the clock:
create_clock -period 4.0 -name ssync_clk_ext 

# Case 5: Alternative Method, FPGA is Receiver
# This design is based on Case 2, except the external clock ssync_clk_ext does not have a 2ns phase-shift.  
# The default setup relationship is 4ns and hold relationship is 0ns
# The external delays were all increased by 2ns, from 0.7ns and -0.6ns to 2.7ns and 1.4ns: 
set_input_delay -clock ssync_clk_ext -max 2.7 [get_ports {ssync_rx_data[*]}]
set_input_delay -clock ssync_clk_ext -min 1.4 [get_ports {ssync_rx_data[*]}]


##### Same Edge Transfer Solution ######
# To run, comment out lines 14-15 and uncomment lines 23-25.  
# Multicycles are necessary to tell TimeQuest that this is a same edge trasfer
# The multicycle modifies the setup relationship to 0ns and the hold relationship to -4ns
# The external delays were all decreased by 2ns, from 0.7ns and -0.6ns to -1.3ns and -2.6ns: 
#set_multicycle_path -setup -from [get_clocks {ssync_clk_ext}] -to [get_clocks {inst1|altpll_component|auto_generated|pll1|clk[0]}] 0
#set_input_delay -clock ssync_clk_ext -max -1.3 [get_ports {ssync_rx_data[*]}]
#set_input_delay -clock ssync_clk_ext -min -2.6 [get_ports {ssync_rx_data[*]}]

