create_clock -period 10.0 -name ssync_rx_clk [get_ports ssync_rx_clk]

# PLL phase-shifts the latching clock by 90 degrees, which will be constrained by derive_pll_clocks:
derive_pll_clocks

derive_clock_uncertainty

################### ADS4149 -> FPGA Interface ####################
# Create virtual clock for clock at ADS4149.  It is identical to the clock coming into FPGA
create_clock -period 10.0 -name ssync_clk_ext

# Tskew from ADS4149 datasheet
set tskew_max 0.5
set tskew_min -0.5

# The board skew need to be accounted for.  Positive means data is longer than clk, negative means it is shorter than clk.  I made up some values:
set board_data2clk_skew_max 0.05
set board_data2clk_skew_min -0.05

# Now just add the ADC skew and board skew to calculate external delays:
set ssync_in_max [expr $tskew_max + $board_data2clk_skew_max] ;# 0.5 + 0.05 = 0.55
set ssync_in_min [expr $tskew_min + $board_data2clk_skew_min] ;# -0.5 + -0.05 = -0.55

set_input_delay -clock ssync_clk_ext -max $ssync_in_max [get_ports {ssync_rx_data[*]}]
set_input_delay -clock ssync_clk_ext -min $ssync_in_min [get_ports {ssync_rx_data[*]}]
set_input_delay -clock ssync_clk_ext -max $ssync_in_max [get_ports {ssync_rx_data[*]}] -clock_fall -add_delay
set_input_delay -clock ssync_clk_ext -min $ssync_in_min [get_ports {ssync_rx_data[*]}] -clock_fall -add_delay
##################################################################

